package utils.numbers {
	
	/**
	 * Битовая маска с возможностью получать и записывать биты
	 * 
	 * @author gloomyBrain
	 */
	public class BitMask {
		
		private var _value:uint;
		
		/**
		 * @param	value	Начальное значение для маски
		 */
		public function BitMask(value:uint = 0) {
			
			_value = value;
			
		}
		
		/**
		 * Получает бит по индексу
		 * (К.О.: биты идут справа налево, начиная с 0)
		 * 
		 * @param	index	Индекс бита
		 * 
		 * @return			true, если значение бита равно 1 
		 * 					или false, если 0
		 */
		public function getBitAt(index:uint):Boolean {
			return Boolean(_value & (1 << index));
		}
		
		/**
		 * Задает значение бита в заданном индексе
		 * (К.О.: биты идут справа налево, начиная с 0)
		 * 
		 * @param	index	Индекс бита
		 * @param	value	Новое значение (true для 1, false для 0)
		 */
		public function setBitAt(index:uint, value:Boolean = true):void {
			
			var currentState:Boolean = this.getBitAt(index);
			if (value == currentState) return;
			
			_value += value ? -(1 << index) : (1 << index);
			
		}
		
		/**
		 * Текущее числовое значение
		 */
		public function get value():uint {
			return _value;
		}
		
	}

}